﻿# -*- coding: utf-8 -*-

# File: PageColumn.py
#
# Copyright (c) 2006 by []
# Generator: ArchGenXML Version 1.4.1
#            http://plone.org/products/archgenxml
#
# GNU General Public License (GPL)
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
# 02110-1301, USA.
#

__author__ = """Max M <maxm@mxm.dk>"""
__docformat__ = 'plaintext'

# cmf imports
#from Products.CMFCore.utils import getToolByName
from Products.CMFCore.CMFCorePermissions import View

from AccessControl import ClassSecurityInfo
from Products.Archetypes.atapi import *
from Products.ATReferenceBrowserWidget.ATReferenceBrowserWidget import *

# product
from Products.PageBuilder.config import *
from Common import Common


schema = Schema((

    StringField(
        name='title',
        accessor='Title',
        required=False,
        widget=StringWidget(
            label='Title',
            label_msgid='PageBuilder_label_title',
            i18n_domain='PageBuilder',
        )
    ),

    TextField(
        name='description',
        accessor='Description',
        widget=TextAreaWidget(
            label='Description',
            label_msgid='PageBuilder_label_description',
            i18n_domain='PageBuilder',
        )
    ),

    TextField('text',
        default_content_type='text/html',
        default_output_type='text/html',
        allowable_content_types=('text/plain', 'text/structured', 'text/html',),
        widget=RichWidget(
            label='Text',
            label_msgid='PageBuilder_label_text',
            description_msgid='PageBuilder_help_text',
            i18n_domain='PageBuilder',
        ),
    ),

    StringField(
        name='macroName',
        vocabulary='getMacrosDisplayList',
        default_method='getDefaultMacro',
        widget=SelectionWidget(
            label='Style',
            label_msgid='PageBuilder_label_rowMacro',
            i18n_domain='PageBuilder',
        )
    ),

    # static items

    ReferenceField(
        name='staticList',
        relationship='PageBuilder_staticItems',
        multiValued = 1,
        allowed_types = (),
        widget=ReferenceBrowserWidget(
            label='Selected items',
            label_msgid='PageBuilder_label_staticList',
            i18n_domain='PageBuilder',
            startup_directory='/',
        ),
        schemata='Select items',
    ),

    LinesField(
        name='staticList_visibleFields',
        multiValued=True,
        vocabulary='fieldsDisplaylist',
        default = ('title', 'description', 'date', 'author', 'email', 'image', 'link',),
        widget=MultiSelectionWidget(
            size = 10,
            label='Visible fields for selected items',
            label_msgid='PageBuilder_label_topic_visibleFields',
            i18n_domain='PageBuilder',
        ),
        schemata='Select items',
    ),

    StringField(
        name='staticList_linkText',
        widget=StringWidget(
            label='Linktext for selected items',
            label_msgid='PageBuilder_label_staticList_linkText',
            i18n_domain='PageBuilder',
        ),
        schemata='Select items',
    ),


    # Topic

    ReferenceField(
        name='topic',
        relationship='PageBuilder_topics',
        multiValued = 0,
        allowed_types = ('Topic',),
        widget=ReferenceBrowserWidget(
            label='Topic',
            label_msgid='PageBuilder_label_topic',
            i18n_domain='PageBuilder',
            startup_directory='/',
        ),
        schemata='Topic stylings',
    ),


    LinesField(
        name='topic_visibleFields',
        multiValued=True,
        vocabulary='fieldsDisplaylist',
        default = ('title', 'description', 'date', 'author', 'email', 'image', 'link',),
        widget=MultiSelectionWidget(
            size = 10,
            label='Topic visible fields',
            label_msgid='PageBuilder_label_topic_visibleFields',
            i18n_domain='PageBuilder',
        ),
        schemata='Topic stylings',
    ),


    StringField(
        name='topic_linkText',
        widget=StringWidget(
            label='Topic linktext',
            label_msgid='PageBuilder_label_topic_linkText',
            i18n_domain='PageBuilder',
        ),
        schemata='Topic stylings',
    ),


),
)


PageColumn_schema = BaseSchema.copy() + \
    schema.copy()


class PageColumn(BaseContent, Common):
    security = ClassSecurityInfo()
    __implements__ = (getattr(BaseContent,'__implements__',()),)

    # This name appears in the 'add' box
    archetype_name = 'PageColumn'

    meta_type = 'PageColumn'
    portal_type = 'PageColumn'
    allowed_content_types = []
    filter_content_types = 0
    global_allow = 0
    allow_discussion = False
    #content_icon = 'PageColumn.gif'
    immediate_view = 'pagebuilder_redirect'
    default_view = 'pagebuilder_redirect'
    suppl_views = ('pagebuilder_redirect',)
    typeDescription = "PageColumn"
    typeDescMsgId = 'description_edit_pagecolumn'

    schema = PageColumn_schema

    # column macros template
    MACRO_TEMPLATES = 'PageBuilder_colMacros'
    # This macro *must* be present.

    actions = (
        {
            'id': 'view',
            'name': 'View',
            'action': 'pagebuilder_redirect',
            'permissions': (View,)
        },
    )

    security.declarePublic('fieldsDisplaylist')
    def fieldsDisplaylist(self):
        "Returns displaylist of possible fields"
        fields = self.PageBuilder_fields()
        return DisplayList(fields)

    security.declareProtected(View, 'getDynamicList')
    def getDynamicList(self, full_objects=False):
        "Returns objects for Topic"
        topic = self.getTopic()
        if topic is None:
            return []
        else:
            return topic.queryCatalog(full_objects=full_objects)



registerType(PageColumn,PROJECTNAME)
# end of class PageColumn

##code-section module-footer #fill in your manual code here
##/code-section module-footer



