﻿# -*- coding: utf-8 -*-

# File: PageRow.py
#
# Copyright (c) 2006 by []
# Generator: ArchGenXML Version 1.4.1
#            http://plone.org/products/archgenxml
#
# GNU General Public License (GPL)
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
# 02110-1301, USA.
#

__author__ = """Max M <maxm@mxm.dk>"""
__docformat__ = 'plaintext'

# cmf imports
#from Products.CMFCore.utils import getToolByName
from Products.CMFCore.CMFCorePermissions import View

from AccessControl import ClassSecurityInfo, Unauthorized
from Products.Archetypes.atapi import *

# product
from Products.PageBuilder.config import *
from Common import Common

# how many columns should be in a row
MAX_N_COLUMNS = 3

schema = Schema((

    StringField(
        name='title',
        accessor='Title',
        required=False,
        widget=StringWidget(
            label='Title',
            label_msgid='PageBuilder_label_title',
            i18n_domain='PageBuilder',
        )
    ),

    StringField(
        name='macroName',
        default_method='getDefaultMacro',
        widget=StringWidget(
            label='Rowmacro',
            label_msgid='PageBuilder_label_rowMacro',
            i18n_domain='PageBuilder',
        )
    ),

),
)

PageRow_schema = BaseFolderSchema.copy() + \
    schema.copy()

class PageRow(BaseFolder, Common):
    security = ClassSecurityInfo()
    __implements__ = (getattr(BaseFolder,'__implements__',()),)

    # This name appears in the 'add' box
    archetype_name = 'PageRow'

    meta_type = 'PageRow'
    portal_type = 'PageRow'
    allowed_content_types = ['PageColumn', 'Topic', 'Image']
    filter_content_types = 1
    global_allow = 0
    allow_discussion = False
    #content_icon = 'PageRow.gif'
    immediate_view = 'base_view'
    default_view = 'base_view'
    suppl_views = ('base_view',)
    typeDescription = "PageRow"
    typeDescMsgId = 'description_edit_pagerow'

    schema = PageRow_schema

    # column macros template
    MACRO_TEMPLATES = 'PageBuilder_rowMacros'

    actions = (
        {
            'id': 'view',
            'name': 'View',
            'action': 'base_view',
            'permissions': (View,)
        },
    )

    security.declarePrivate('at_post_create_script')
    def at_post_create_script(self):
        "Adds the first row automatically"
        for i in range(1, MAX_N_COLUMNS+1):
            columnId = 'col_%s' % i
            self.invokeFactory('PageColumn', columnId)
            try:
                topicId = 'topic_%s' % i
                self.invokeFactory('Topic', topicId)
                column = getattr(self, columnId)
                topic = getattr(self, topicId)
                column.setTopic(topic)
            except Unauthorized:
                pass # user does not have permission to add topics.


    security.declareProtected(View, 'getPageColumns')
    def getPageColumns(self):
        "Returns the sorted list of page rows"
        # Can filter on allowed types, for easy plugin in if needed
        return self.listFolderContents(contentFilter={'portal_type':'PageColumn'})


registerType(PageRow,PROJECTNAME)
# end of class PageRow

##code-section module-footer #fill in your manual code here
##/code-section module-footer



